macroScript GMAX2Nebula
-- This file was created by tom@3D-Inferno.com by using it or changing you agree to the provided
-- license
--
--

category:"3DI"
internalcategory:"3DI"
ButtonText:"gMax 2 N2" 
-- ########################################################################################################################
tooltip:"N2 gMax Export" 
(
	-- ########################################################################################################################
	-- rollouts vars
	local gw
	local TestX
	local TestY
	local N2version = "2.01"
	local outType = 1 			-- 1 gmax listener, 2 is file system  NOT USED
	local gmaxStringLen = 10000 --set it down to gmax maximum for listener selection NOT USED
	local gmaxFile = stringstream ""

	-- ########################################################################################################################
	-- rollout functions
	
	-- gmax detected tur or false
	fn isgmax = 	
	(
		return cylgizmo == undefined 
	)
	
	-- outputs a TCL default shapenode script with a default material to stream
	fn AddShapeNodeToStream obj mesh indent stream =
	(
		ind = ""

		for i in  1 to indent do
		(
			ind = ind + "  "
		)
			
		format "%new nshapenode %\n" ind obj.name to:stream
    	format "%sel %\n" ind obj.name to:stream

		p = obj.pos
		r = quatToEuler obj.rotation
	--	r = obj.rotation
		s = obj.scale
		
		format "%  .setscale % % %\n" ind s.x s.y s.z to:stream
		format "%  .setposition % % %\n" ind p.x p.y p.z to:stream
		format "%  .seteuler % % %\n" ind r.x r.y r.z to:stream
	--	format "%  .setquat % % % %\n" ind r.x r.y r.z r.w to:stream

	-- dummy material !
    	format "%  .setvector \"MatDiffuse\" 1.000000 1.000000 0.539320 0.539320\n" ind to:stream
	    format "%  .setvector \"MatSpecular\" 0.800000 0.800000 0.800000 1.000000\n" ind to:stream
	    format "%  .setfloat \"MatSpecularPower\" 32.000000\n" ind to:stream
	    format "%  .settexture \"DiffMap0\" \"textures:examples/brick.bmp\"\n" ind to:stream
	    format "%  .settexture \"BumpMap0\" \"textures:examples/bump.tga\"\n" ind to:stream
	    format "%  .setshader \"colr\" \"shaders:default.fx\"\n" ind to:stream
	    format "%  .setmesh \"meshes:examples/%\"\n" ind mesh to:stream
	    format "%  .setgroupindex 0\n" ind to:stream
	    format "%sel ..\n" ind to:stream
     	OK
	)
	
	----------------------------------------------------------------------------------
	-- compute tangentspace and returns an array of 6 verts  (tangent binormal tang..)
	-- corresponding to the face indices
	-- 
	fn gettspace obj face =
	(
		tangentspace = #()
		local ts_p1 = getVert obj face[1]
		local ts_p2 = getVert obj face[2]
		local ts_p3 = getVert obj face[3]
		local ts_a1 = ts_p2-ts_p1
		local ts_a2 = ts_p3-ts_p1
		local ts_t1 = getTVert obj face[1]
		local ts_t2 = getTVert obj face[2]
		local ts_t3 = getTVert obj face[3]
		local ts_b1 = (ts_t2.x-ts_t1.x)
		local ts_b2 = (ts_t3.x-ts_t1.x)
		local ts_c1 = (ts_t2.y-ts_t1.y)
		local ts_c2 = (ts_t3.y-ts_t1.y)
		local ts_v1 = [ts_a1.x,ts_b1,ts_c1]-- as point3
		local ts_w1 = [ts_a2.x,ts_b2,ts_c2]-- as point3
		local ts_x1 = cross ts_v1 ts_w1
		local ts_v2 = [ts_a1.y,ts_b1,ts_c1]-- as point3
		local ts_w2 = [ts_a2.y,ts_b2,ts_c2]-- as point3
		local ts_x2 = cross ts_v2 ts_w2
		local ts_v3 = [ts_a1.z,ts_b1,ts_c1]-- as point3
		local ts_w3 = [ts_a2.z,ts_b2,ts_c2]-- as point3
		local ts_x3 = cross ts_v3 ts_w3
		local ts_e1 = [0,0,0] -- as point3
		local ts_e2 = [0,0,0] 
		local ts_e3 = [0,0,0] 
		local ts_e4 = [0,0,0] 
		local ts_e5 = [0,0,0] 
		local ts_e6 = [0,0,0] 
		if(ts_x1.x != 0) then
		(
			ts_x1 = normalize (ts_x1)
			ts_e1.x = -ts_x1.y/ts_x1.x
			ts_e2.x = -ts_x1.z/ts_x1.x
			ts_e3.x = ts_e1.x
			ts_e4.x = ts_e2.x
			ts_e5.x = ts_e1.x
			ts_e6.x = ts_e2.x
		)
		if(ts_x2.x != 0) then
		(
			ts_x2 = normalize (ts_x2)
			ts_e1.y = -ts_x2.y/ts_x2.x
			ts_e2.y = -ts_x2.z/ts_x2.x
			ts_e3.y = ts_e1.x
			ts_e4.y = ts_e2.x
			ts_e5.y = ts_e1.x
			ts_e6.y = ts_e2.x
		)
		if(ts_x3.x != 0) then
		(
			ts_x3 = normalize (ts_x3)
			ts_e1.z = -ts_x3.y/ts_x3.x
			ts_e2.z = -ts_x3.z/ts_x3.x
			ts_e3.z = ts_e1.x
			ts_e4.z = ts_e2.x
			ts_e5.z = ts_e1.x
			ts_e6.z = ts_e2.x
		)	
		
		tangentspace[1] = ts_e1
		tangentspace[2] = ts_e2
		tangentspace[3] = ts_e3
		tangentspace[4] = ts_e4
		tangentspace[5] = ts_e5
		tangentspace[6] = ts_e6
		
		tangentspace
	)	
	

	----------------------------------------------------------------------------------
	-- Output mesh in nebula 2 intermediate format
	-- TODO flag for found genmeshes which will be relocated !!
	-- 		non gen meshes are unique meshes
	fn OutputMesh2 obj meshbase name doSwap doReOrigin doNormals doTangentspace doColors =
	(
		local outFile = undefined
	
		if(gMax) then
		(
			outFile = listener
			format "\n#place following content in file: %\n#######################################################\n" ("meshes\\"+name+".n3d2") to:outFile
		)
		else
		(  
	  		local fname = meshbase +"\\"+name+".n3d2"

	  		outFile = createFile fname
			if outFile == undefined then
			(
				MessageBox "Couldn't open file for writing !"
	  			return undefined
			)
		)
		
	  	-- nebula must have same amount of verts, textures and normals in n3d file
	  	-- textures and normals are completetly apart from verts, so we catch them by face index

	  	-- check texture
		if (getNumTVerts obj==0) then
		(
			local message = "Export aborted: No UV maps assigned to genmesh object: " + obj.name
			messageBox message
			close outFile 
			return 1
		)
	
		-- vertexcomps coord normal uv0 uv1 uv2 tangent binormal weights jindices
		format "type n3d2\n" to:outFile
		format "numgroups 1\nnumvertices %\nvertexwidth 8\nnumtris %\n" (obj.numfaces*3) obj.numfaces to:outFile
		format "numedges 0\n" to:outFile
		
		if doNormals then
			format "vertexcomps coord normal uv0 " to:outFile
		else 
			format "vertexcomps coord uv0 " to:outFile
			
		if doTangentspace then
			format "tangent binormal" to:outFile

		format "\ng 0 % 0 % " (obj.numfaces*3) obj.numfaces to:outFile
		-- edge definitions
		format "0 0\n" to:outFile
			
		local face = undefined
			
		for i=1 to obj.numfaces do
		(
			face = getFace obj i
			local ts = #()
			if doTangentspace then 
			(
				ts = gettspace obj face
			)
			
			for h=1 to 3 do 
			(
				-- verts
				vert = (in coordsys local getVert obj face[h])
				if doReOrigin then
				(
					xvert = (vert.x - (in coordsys local obj.pos.x))
					yvert = (vert.y - (in coordsys local obj.pos.y))
					zvert = (vert.z - (in coordsys local obj.pos.z))	
					if doSwap then swap yvert zvert
					format "v % % %" xvert yvert zvert to:outFile
				)
				else
				(
					xvert = (vert.x)
					yvert = (vert.y)
					zvert = (vert.z)	
					if doSwap then swap yvert zvert
					format "v % % %" xvert yvert zvert to:outFile
 				)
				
				--normal
				if doNormals then
				(
					normal = normalize (in coordsys local getNormal obj face[h])
					if doSwap then swap normal.y normal.z
					format " % % %" normal.x normal.y normal.z to:outFile
				)
				
				-- tex
				vert = (getTVert obj face[h])	
				format " % %" vert.x vert.y to:outFile						
				
				if doTangentspace then 
				(
				  if ts.count < 6 then
				  (
				  	message "tangentspace not complete for face "+i+" on object "+obj.name
					messageBox message
					return 1
				  )
				  else
				  (
				  	local t = normalize(ts[h*2-1] as point3)
					local b = normalize(ts[h*2] as point3)							
				  	format " % % % % % %" t.x t.y t.z b.x b.y b.z to:outFile
				  )
				)
				-- last
				format "\n" to:outFile
			)--end of for each face index
		)-- end of for each face
	
		-- face
		-- revert order if scale is negative
		if ((obj.scale.x < 0) and (obj.scale.y < 0) and (obj.scale.z < 0) )then
		(
			for i =0 to (obj.numFaces-1) do
			(	
				a = (i*3) 
				b = (a+1)
				c = (a+2)
				if doSwap then swap b c
				format "t % % %\n" c  b a to:outFile
		    )
		)
		else
		(
			for i =0 to (obj.numFaces-1) do
			(	
				a = (i*3) 
				b = (a+1)
				c = (a+2)
				if doSwap then swap b c
				format "t % % %\n" a  b c to:outFile
		    )		
		)
		
		if(gMax) then
			format "\n#######################################################\n" to:outFile
		else
			close outFile 
	) -- end of OutputMesh2

	
	-- ########################################################################################################################
	-- THE rollout
	-- parameters for nebula 2 intermediate export
	rollout TestY "Export to Nebula 2" width:250 height:400
	(
		edittext edt3 "" pos:[17,32] width:192 height:21
		label lbl1 "Save in directory:" pos:[21,7] width:142 height:20
		button btn2 "Export" pos:[37,110] width:152 height:24
		label lbl6 "XYZ Scale:" pos:[21,72] width:60 height:20
		edittext edtScale "" pos:[101,67] width:63 height:24
		checkbox chkReOrg "Re-origin objects" pos:[4,146] width:130 height:20 checked:true
		checkbox chkYZswap "Swap Y Z" pos:[160,146] width:90 height:20 checked:true
		checkbox chkTangent "Export tangentspace" pos:[4,175] width:140 height:20 checked:false
		checkbox chkNormal "N" pos:[160,175] width:90 height:20 checked:true
		
		fn load_settings =
		(
			start = fileproperties.findproperty #custom "'N2-version" 				
			if start != 0 then 				
			( 		
				edt3.text = fileproperties.getpropertyvalue #custom (start+1) 
				edtScale.text = fileproperties.getpropertyvalue #custom (start+2)
				chkReOrg.checked = fileproperties.getpropertyvalue #custom (start+3)
				chkYZswap.checked = fileproperties.getpropertyvalue #custom (start+4)
				chkTangent.checked = fileproperties.getpropertyvalue #custom (start+5)
				chkNormal.checked = fileproperties.getpropertyvalue #custom (start+6)
				return true
			)
			return false
		)
		
		fn save_settings =
		(			
			fileproperties.addproperty #custom "'N2-version" N2version
			fileproperties.addproperty #custom "'N2-directory" edt3.text
			fileproperties.addproperty #custom "'N2-rescale" edtScale.text
			fileproperties.addproperty #custom "'N2-reorigin" chkReOrg.checked
			fileproperties.addproperty #custom "'N2-YZswap" chkYZswap.checked

			fileproperties.addproperty #custom "'N2-tangentspace" chkTangent.checked
			fileproperties.addproperty #custom "'N2-normals" chkNormal.checked
			return true
		)
		
		
		on TestY open do   
		(
			if( not (load_settings()) ) then
			(
		   		edt3.text = "C:\\tmp\\export"
		   		edtScale.text = "1.0"
			)
				
		)
		
		on TestY close do
		(
			save_settings()
		)
	
		on btn2 pressed do
		(
		
			-- ////////////////////////
			-- Variables used in the program
			-- ////////////////////////
		
			-- get filename
			local scriptbase = edt3.text +"\\"
			local filename = scriptbase +"load.tcl"
			local meshbase = scriptbase + "meshes\\"
			local texbase = scriptbase + "textures\\"
			
			-- set debug output
			global debug=true

			if (isgmax()) then
			(			
				global gMax=true
				messagebox "GMax detected! Exporting to listener, will break if export scene is too big."
			)
			else
				global gMax=false

			-- Define verbose output (that takes more space and memory)
			local verboseMode = true
		
			-- parameters for scaling and relocation
			global tot_scale = edtScale.text as Float


			-- output file
			if( not gMax) then
			(
				makeDir scriptbase
				makeDir meshbase
				makeDir texbase
				outFile = createFile filename
			)
			else
			(
				outFile = gmaxFile
				format "#place following content in file load.tcl\n" to:outFile
			)
			
			if (debug and not gMax) then format "Created file: % and dirs % % %\n" filename scriptbase meshbase texbase	

	  		format "# ---\n" to:outFile
	  		format "# $parser:ntclserver$ $class:ntransformnode$\n" to:outFile
			format "# ---\n" to:outFile
			format ".setposition 0.000000 0.000000 0.000000\n" to:outFile
			format ".setscale % % %\n" tot_scale tot_scale tot_scale to:outFile

			format "\n" to:outFile

			-- do this to catch all objects, including grouped subobjects
			erg = #()
			join erg objects

			for obj in erg do 
			(
				if( (isKindOf  obj Shape) or (isKindOf  obj Light) or (isKindOf  obj Camera) or
					(isKindOf  obj  Helper) or (isKindOf  obj Helper) or (isKindOf  obj SpacewarpObject) ) then
				(
					format "Skipping Object % of invalid type\n" obj.name
					continue
				)
					
			   --if( isKindOf  obj GeometryClass ) then
			   --		format "Object % is a geometry object\n" obj.name
				
			   -- determine number of materials on object 		   
			   if (obj.mat == undefined) then 
			   (
					format "   OBJECT % HAS NO MATERIAL! Object will be skipped.\n" obj.name
					continue
			   )
			   else if ((classOf obj.mat)==standardMaterial) then 
			   		numMat = 1
			   else 
			   		numMat = obj.mat.count
			   
			   if(obj != undefined)then
			   (
			     dump = undefined
			     dump = copy obj
				 dump.name = obj.name -- will receive a new number ! so we need to do this
				 convertToMesh dump
			   	 OutputMesh2 dump meshbase obj.name chkYZswap.checked chkReOrg.checked chkNormal.checked chkTangent.checked false
				 mesh ="meshes/"+obj.name+".n3d2"
				 --messagebox dump.name
				 AddShapeNodeToStream dump mesh 1 outFile
				 delete dump
			   )
			) 

	        format "# ---\n"  to:outFile 
			format "# Eof\n"  to:outFile 
			if(gMax) then
				format "%" (gmaxFile as string) to:listener
			close outFile 
			gc()
		
			message = "...=TM=..."
			messageBox message
		
		)
	)

	-- startup of rollout
	gw = newRolloutFloater "Export Level" 300 400 
	addRollout TestY gw 
) 